#include <stdio.h>
#include <math.h>
#include <omp.h>

#define ACCURACY 50000000

double f(double x){
  return x*x;
}

double trapezoid_area(double a, double b, double h){
  return (a+b)/2*h;
}

int main(int argc, char** argv){
  double from=10,to=145;
  double sum=0;
  double dx=(to-from)/ACCURACY;
  
  omp_set_num_threads(1);

  #pragma omp parallel shared(sum)
  {
    #pragma omp for reduction(+:sum)
    for(int i=0;i<ACCURACY; i++){
      double x1=dx*i+from;
      double x2=x1+dx;
      sum+=trapezoid_area(f(x1),f(x2),dx);
    }

  }

  printf("Integral of f() from %lf to %lf is %lf\n", from,to,sum);
  return 0;
}
