#include <stdio.h>
#include <omp.h>

#define TRIALS 10

// Shared counter
int val = 0;
omp_lock_t l;

void inc()
{
  omp_set_lock(&l);
  val++;
  omp_unset_lock(&l);
}

int main(int argc, char **argv)
{
  int nthreads=10;
  omp_init_lock(&l);
  omp_set_num_threads(nthreads);

  // Perform parallel increments
  #pragma omp parallel
  {
    for(int i=0;i<TRIALS;i++){
      inc();
    }
  }

  // Show results
  if (val != nthreads*TRIALS)
    printf("ERROR val=%d should be %d\n", val,nthreads*TRIALS);
  else
    printf("SUCCESS val=%d\n", val);

  omp_destroy_lock(&l);
  return 0;
}
